#ifndef _ENPRESS_H_

#define _ENPRESS_H_

#include <stdio.h>
#include <string.h>
#include "config.h"
#ifdef USE_OPENSSL
#include <openssl/evp.h>
#endif
#ifdef USE_ZLIB
#include <zlib.h>
#endif

#ifdef USE_OPENSSL
struct _encryption_contexts {
	unsigned char key[EVP_MAX_KEY_LENGTH];
	unsigned char iv[EVP_MAX_KEY_LENGTH];
};

typedef struct _encryption_contexts * EncryptInfo;


int encrypt_buffer(EncryptInfo,unsigned char *,unsigned char *,int *);
int decrypt_buffer(EncryptInfo,unsigned char *,unsigned char *,int);
EncryptInfo generate_key(unsigned char *);
#endif

#ifdef USE_ZLIB

#endif

#define CHECK_ERR(err,msg) { \
	if(err != Z_OK) { \
		fprintf(stderr,"%s error: %d",msg,err); \
	} \
}

#endif
