/* This file is part of Chunky Monkey IRCD 
 *
 * Chunky Monkey IRCD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Chunky Monkey IRCD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Chunky Monkey IRCD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $Id: cmd_away.c,v 1.8 2002/02/11 20:04:33 lloydy Exp $
 *
 */
#include "chunkyircd.h"
#include "network.h"
#include "utility.h"
#include "modules.h"

/* Version Number */
CMIRCD_MODULE(0.98,CMD_CLIENT | CMD_SERVER);

int cmd_away(ClientInfo c_ptr,ServerInfo s_ptr,Cmd cmd)
{
	int length;
	char buffer[BUF_SIZE];
	int real_length;
	
	if(s_ptr) {
		c_ptr=locate_client(cmd->origin);
	}

	if(!c_ptr) {
		 
		return 0;
	}
	
	/* Set the mode and allocate space */
	if( !(cmd->text) && !(c_ptr->mode & MODE_AWAY) ) {
		 
		return 1;
	}
	
	if(cmd->text) {
		/* Set the away message */
		length=strlen(cmd->text);
		real_length = (length > 200?200:length);
		
		c_ptr->away_msg=string_alloc(real_length);
		strncpy(c_ptr->away_msg,cmd->text,real_length);
		c_ptr->mode |= MODE_AWAY;
		ircd_sprintf(buffer,BUF_SIZE,"AWAY :%s",c_ptr->away_msg);
		servers_relay(s_ptr,c_ptr->nick,buffer);
		
		if(c_ptr->fd!=-1) 
			send_numeric(c_ptr,get_my_server(),306,":No! Don't leave me");
	} else {
		free(c_ptr->away_msg);
		c_ptr->away_msg=NULL;
		c_ptr->mode ^= MODE_AWAY;
		
		ircd_sprintf(buffer,BUF_SIZE,"AWAY");
		servers_relay(s_ptr,c_ptr->nick,buffer);
		
		if(c_ptr->fd!=-1) 
			send_numeric(c_ptr,get_my_server(),305,":You're back! Thank RMS you're back");
	}
	
	 
	return 1;
}
		
		
		
