/* This file is part of Chunky Monkey IRCD 
 *
 * Chunky Monkey IRCD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Chunky Monkey IRCD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Chunky Monkey IRCD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $Id: cmd_pong.c,v 1.7 2002/02/11 17:55:30 lloydy Exp $
 *
 */
#include "chunkyircd.h"
#include "utility.h"
#include "server.h"

/* respond to a pong */
/* I think we should check the target when we go multi-server */
int cmd_pong(ClientInfo c_ptr,ServerInfo s_ptr,Cmd cmd)
{
	ServerInfo dest_ptr=NULL;
	ClientInfo dest_client=NULL;
	char buffer[BUF_SIZE];
	
	
	/* No Target, assume its for us */
	if(!cmd->text) {
		if(c_ptr) {
			c_ptr->flags &= ~USR_PINGSENT;
		} else {
			s_ptr->flags &= ~USR_PINGSENT;
		}
		 
		return 1;
	}

	if(lc_strncmp(cmd->text,server_name,30)==0) {
		if(c_ptr) {
			c_ptr->flags &= ~USR_PINGSENT;
		} else {
			s_ptr->flags &= ~USR_PINGSENT;
		}
		 
		return 1;
	}
	
	/* Forward to another server */
	dest_ptr=locate_server(cmd->text);
	if(!dest_ptr) {
		/* no such target */
		if(s_ptr && (dest_client=locate_client(cmd->text))) {
			ircd_sprintf(buffer,BUF_SIZE,"PONG %s :%s",cmd->origin,cmd->params[0],cmd->text);
			
			send_origin_client(dest_client,cmd->origin,buffer);
		} else {
			/* nope */
			if(c_ptr) {
				ircd_sprintf(buffer,BUF_SIZE,"%s :No such server",cmd->text);
				send_numeric(c_ptr,get_my_server(),402,buffer);
			}
		}		
		
	} else {
		/* Forward */
		ircd_sprintf(buffer,BUF_SIZE,"PONG %s %s",cmd->params[0],cmd->text);
		send_origin_server(dest_ptr,c_ptr->nick,buffer);
	}
	
	 
	/* Return */
	return 1;
}
