/* This file is part of Chunky Monkey IRCD 
 *
 * Chunky Monkey IRCD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Chunky Monkey IRCD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Chunky Monkey IRCD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $Id: cmd_svinfo.c,v 1.5 2001/12/24 14:08:36 lloydy Exp $
 *
 */
#include "chunkyircd.h"
#include "network.h"

/* 
* SVINFO, extension to irc protocol to support
* TS3 protocol
* :prefix SVINFO ts_version ts_min standalone :time
*/
int cmd_svinfo(ClientInfo c_ptr,ServerInfo s_ptr,Cmd cmd)
{
	int ts_ver=0;
	int td=0;
	time_t remote_time;
	
	/* Ignore from clients */
	if(c_ptr) {
		 
		return 0;
	}
	
	if(!(check_params(cmd,3)) || !(cmd->text) ) {
		 
		return 0;
	}

	ts_ver=atoi(cmd->params[0]);
	if(ts_ver > 4)
		s_ptr->ts_version =ts_ver;
	
	/* Get min versionf rom them */
	/* If its greater than ours, disable TS */
	ts_ver=atoi(cmd->params[1]);
	if(ts_ver > 4) 
		s_ptr->ts_version = 0;

	

	td=atoi(cmd->params[2]);
	if(td) {
		/* Check time */
		remote_time=strtoul(cmd->text,NULL,10);
		if(remote_time > time(NULL)) {
			s_ptr->ts_delta=remote_time - time(NULL);
		} else {
			s_ptr->ts_delta=time(NULL) - remote_time;
		}
	}
	
		
	 
	return 1;
}

