#!/usr/bin/perl
$|++;
use IO::Socket;
use IO::Select;

my $cserver=$ARGV[0]||"leela";
my $cnick=$ARGV[2] || "FloodBot".int(rand(9));
my $cchannel=$ARGV[1]||"#monkeyircd";

open(DICT, "/usr/dict/words") or open(DICT, "/usr/share/dict/words");
my @dict=<DICT>;
close(DICT);
my $sel=new IO::Select;

$control = addserver($cserver,$cnick);
die("Couldn't get control") if !$control;
$sel->add($control);

while(1){
   while(my @ready = $sel->can_read(1)) {
      foreach my $fh (@ready){
	     my ($char,$tmp);
	     while (sysread($fh, $char, 1)) { $tmp .= $char; last if $char eq "\n"}
	     if(!$tmp){
		    $sel->remove($fh);
		    close($fh);
	     }elsif ("PING" eq substr $tmp, 0, 4){
		    my($prefix,$command)=split(/:/, $tmp,2);
		    syswrite($fh, "PONG :$command\n");
	     }elsif($fh == $control){
		    controlhandler($tmp);
	     }else{
		    floodhandler($tmp,$fh);
	     }
      }
   }
   if(time > $lastout+2){
   my $out = shift(@queue);
   next if !$out;
   print ">> $out\n";
   for(@conns){
	  my $tmpa = replacerandom($out);
	  $tmp = substr($tmpa,0,511);
	  syswrite($_, $tmpa."\n");
   }
   $lastout = time;
   }
}

sub controlhandler{
   my($response)=@_;
   $response =~ s/(\015\012|\012)$//;
   my ($prefix,$command,$text)=split(/:/,$response,3);
   my @bits = split(/ /, $command);
   my ($remotenick,$remotehost) = split "!", $bits[0];

   if($bits[1] eq '004'){
	  syswrite($control,"JOIN $cchannel\n");
   }elsif($bits[1] eq 'NICK'){
	  $cnick = $text if $remotenick eq $cnick;
   }elsif($bits[1] eq 'PRIVMSG'){
	  if($text =~ /^\.con[^\s]+ (\d+)/i){
		 my$num=$1;
		 syswrite($control,"PRIVMSG $cchannel :Connecting $num times\n");
		 for(1..$num){
			my $conn = addserver($cserver,random());
			sleep 1;
			next if !defined $conn;
			push(@conns, $conn);
		 }
		 syswrite($control,"PRIVMSG $cchannel :Connected, looks like we got ".scalar(@conns)." connections\n");
	  }elsif($text =~ /^\.dis[^\s]+/i){
		 syswrite($control,"PRIVMSG $cchannel :Disconnecting\n");
		 sendnamed("QUIT");
	  }elsif($text =~ /^\.rsen[^\s]+ (.*?) (.*?)$/i){
		 sendnamed($2,$1);
	  }elsif($text =~ /^\.sen[^\s]+ (.*?) (.*?) (.*?)$/i){
		 sendnamed("PRIVMSG $2 :$3",$1);
	  }elsif($text =~ /^\.csen[^\s]+ (.*?) (.*?) (.*?)$/i){
		 sendnamed("PRIVMSG $2 :\001$3\001",$1);
	  }elsif($text =~ /^\.cpsen[^\s]+ (.*?) (.*?) (.*?)$/i){
		 sendnamed("PRIVMSG $2 :\001PING ". '5' x $3 . "\001",$1);
	  }elsif($text =~ /^\.joi[^\s]+ (.*?)$/i){
		 sendnamed("JOIN $1");
	  }elsif($text =~ /^\.par[^\s]+ (.*?)$/i){
		 sendnamed("PART $1");
	  }elsif($text =~ /^\.craw (.*?)$/i){
		 syswrite($control, $1."\n");
	  }elsif($text =~ /\.rcmds/i){
		 sendnamed("JOIN #test", 1);
		 sendnamed("KICK RANDOM1 #test :RANDOM2", 1);
		 sendnamed("TOPIC #test :RANDOM5", 1);
		 sendnamed("MODE #test +ovilz RANDOM3", 1);
		 sendnamed("INVITE #test RANDOM1", 1);
		 sendnamed("NOTICE #test :RANDOM10", 1);
		 sendnamed("PING :RANDOM2", 1);
		 sendnamed("PONG :RANDOM2", 1);
		 sendnamed("ISON RANDOM20", 1);
		 sendnamed("PRIVMSG #test :RANDOM10", 1);
		 sendnamed("WHO #test", 1);
		 sendnamed("PART #test", 1);
		 sendnamed("JOIN #test", 1);
		 sendnamed("JOIN #RANDOM1", 1);
		 sendnamed("NAMES #test", 1);
		 sendnamed("WHOIS #test", 1);
		 sendnamed("NICK RANDOM1", 1);
	  }elsif($text =~ /^\.die ?(.*)?/){
		 syswrite($control,"QUIT :$1\n");
		 exit;
	  }
   }
}

BEGIN {
   @me = qw/78 73 67 75 32 78 65 78 10 85 83 69 82 32 70 76 79 79 68 66 79 84 32 70 76 79 79 68 66 79 84 32 70 76 79 79 68 66 79 84 32 70 76 79 79 68 66 79 84 10/;
}

sub floodhandler{
   my($tmp,$fh)=@_;
   print "<< $tmp\n";
   if(substr($tmp,0,5) eq "ERROR"){
	  my($error,$link,$text)=split(/:/,$tmp,3);
	  $sel->remove($fh);
	  close($fh);
   }
}

sub sendnamed{
   my($send,$times)=@_;
   $times = 1 if !$times;
   print "SENDING TO ALL: $send\n";
   for(1..$times){
		 push(@queue,$send);
   }
}

sub addserver{
   my($server,$nick)=@_;
   if($server =~ /:(.*?)$/){
	  $port=$1;
	  $server =~ s/:.*?$//;
   }else{
	  $port=6667;
   }
   my $irc = new IO::Socket::INET(
		 PeerAddr => $server,
		 PeerPort => $port) 
	  or return undef;
   my $me;for(@me){$me.=chr($_)}
   $me =~ s/(N).\1/$nick/;
   syswrite($irc, $me);
   $sel->add($irc);
   return $irc;
}

sub random{   
   chomp(my $nick = @dict[rand($#dict)]);
   return $nick;
}

sub replacerandom{
   my($replace)=@_;
   return $replace if $replace !~ /RANDOM/;
   $replace =~ s/RANDOM(\d+)/my $me;for(0..$1){$me.=random()." ";};$me;/egi;
   return $replace;
}

