# Perl Test Script - Used to test the server logon routines
# Logs in, prints remote server details
# Replies to pings and echos every data sent to us

use IO::Socket::INET;


$my_name = "irc.test.com";
$remote_addr = "192.168.0.10";
$remote_port = "6667";
$my_info = "Local PERL Test Client";

$server = IO::Socket::INET->new(PeerAddr => $remote_addr,
				PeerPort => $remote_port,
				Proto    => "tcp",
				Type     => SOCK_STREAM)

	or die "Couldn't connect to the server\n";


print "Chunky Monkey IRCD - Perl Server Imitation Script\n";
print "Chunky Monkey IRCD is licensed under the GNU GPL\n";
print "Copyright (c) Chris Plant 2000-2001\n";
print "              David G. Leadbetter 2001\n";

print $server "server $my_name 0 1 :$my_info\n";
print "Sent our details\n";

while(<$server>) {
	print;
	chomp;
	($firsts,$text) = split ":";
	@cmdparams = split  " ",$firsts;
	
	if (lc $cmdparams[0] eq "ping") {
		print $server "PONG $text :$cmdparams[1]\n";
		print "PONG $text :$cmdparams[1]\n";
		print "Replied to a ping\n";
		
	}

	if (lc $cmdparams[0] eq "server") {
		print "Remote server name: $cmdparams[1]\n";
		print "Remote server info: $text\n";
	}
	
}
